// AudioClass
#ifndef AudioClassH
#define AudioClassH

#include <windows.h>
#include <mmsystem.h>
//MUST BE LINKED WITH WinMM.Lib !

#define BLOCK_SIZE 8192
#define BLOCK_COUNT 20

#include "hinstance.h"

static CRITICAL_SECTION waveCriticalSection;
static WAVEHDR* waveBlocks;
static volatile int waveFreeBlockCount;
static int waveCurrentBlock;

class AudioClass{
public:
	AudioClass();
	~AudioClass();
	
	int error;	//flag to show error occured
	
	//size must be 2^N but lesser than BLOCK_SIZE*BLOCK_COUNT
	void writeAudio(unsigned char* data, int size);
	int FreeBlocksCnt();

private:
	HWAVEOUT hWaveOut; /* device handle */
	WAVEFORMATEX wfx; /* look this up in your documentation */

	WAVEHDR* allocateBlocks(int size, int count);
	void freeBlocks(WAVEHDR* blockArray);
	
	static void CALLBACK waveOutProc(HWAVEOUT hWaveOut, UINT uMsg, 	DWORD dwInstance, DWORD dwParam1, DWORD dwParam2 ){
		int* freeBlockCounter = (int*)dwInstance;
		if(uMsg != WOM_DONE)
			return;
		EnterCriticalSection(&waveCriticalSection);
		(*freeBlockCounter)++;
		LeaveCriticalSection(&waveCriticalSection);
		TimerCallBack();
	}
};

#endif
