//FileClass

#include "FileClass.h"
#include "AnsiString.h"

FileClass::FileClass(char* fname,int RW){
	char msg[500];
	RWflag=NOP;
	tempBuf=NULL;
	if(RW==READ){
		if((hFile = CreateFile(fname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL)) == INVALID_HANDLE_VALUE) {
			sprintf(msg,"Unable to open file:\n%s",fname);
			ShowError(msg,"File open error");
			return;
		}
		RWflag=RW;
	}
	if(RW==WRITE){
		if((hFile = CreateFile(fname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL)) == INVALID_HANDLE_VALUE) {
			sprintf(msg,"Unable to open file:\n%s",fname);
			ShowError(msg,"File open error");
			return;
		}
		RWflag=RW;
	}
}

FileClass::~FileClass(){
	if(hFile!=INVALID_HANDLE_VALUE)CloseHandle(hFile);
	if(tempBuf)delete tempBuf;
}

int FileClass::Read (unsigned char* buf, int size){
	DWORD readBytes;
	if(RWflag!=READ){
		ShowError("Unable to read the file !","File read error");
		return 0;
	}
	if(!ReadFile(hFile, buf, size, &readBytes, NULL))
		return 0;
	return (int)readBytes;
}

int FileClass::Write(unsigned char* buf, int size){
	DWORD wtiteBytes;
	if(RWflag!=WRITE){
		ShowError("Unable to write the file !","File write error");
		return 0;
	}
	if(!WriteFile(hFile, buf, size, &wtiteBytes, NULL))
		return 0;
	return (int)wtiteBytes;
}

//ENDF is returned when end of file
int FileClass::GetC(){
	int res;
	if(!tempBuf){
		tempBuf=new unsigned char[BUFSIZE];
		bufpoi=1;
		eofloc=BUFSIZE;
		if(!Read(tempBuf,BUFSIZE))return ENDF;
		return tempBuf[0];
	}
	if(bufpoi>=eofloc)return ENDF;
	res=tempBuf[bufpoi++];
	if(bufpoi>=BUFSIZE){
		bufpoi=0;
		eofloc=Read(tempBuf,BUFSIZE);
	}
	return res;
}

//buffer flushed when FLUSH is written with PutC
void FileClass::PutC(int c){
	if(!tempBuf){
		tempBuf=new unsigned char[BUFSIZE];
		tempBuf[0]=c;
		bufpoi=1;
		return;
	}
	if(c==FLUSH)
		Write(tempBuf,bufpoi);
	tempBuf[bufpoi++]=c;
	if(bufpoi>=BUFSIZE){
		Write(tempBuf,BUFSIZE);
		bufpoi=0;
	}
}
