#include "FormClass.h"

//Main Form creation
void FormClass::Create(char * AppName,int Wid,int Hei){
	WID=Wid;HEI=Hei;
    CreateHidden(AppName,Wid,Hei);
    ChildOfMainForm=0;
    ShowWindow (hwnd, Fstil);
    Visible=true;
}

//Hidden Child - Show() can be applicable
void FormClass::CreateHidden(char * AppName,int Wid,int Hei){
	WID=Wid;HEI=Hei;
  
    WNDCLASSEX wincl;        // Data structure for the windowclass 

    ChildOfMainForm=1;
    Visible=false;

    // The Window structure
    wincl.hInstance = hInst;
    wincl.lpszClassName = AppName;
    wincl.lpfnWndProc = InitialWndProc;        // This function is called by windows 
    wincl.style = CS_DBLCLKS;                  // Catch double-clicks 
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 // No menu
    wincl.cbClsExtra = 0;                      // No extra bytes after the window class 
    wincl.cbWndExtra = 0;                      // structure or the window instance 
    wincl.hbrBackground = (HBRUSH) COLOR_WINDOW ;

    // Register the window class, and if it fails quit the program 
    if (!RegisterClassEx (&wincl)){
        MessageBox(NULL, TEXT("Error registering class"), TEXT("ERROR"), MB_OK | MB_ICONEXCLAMATION);
        return;
    }

    // The class is registered, let's create the program
    hwnd = CreateWindowEx (
           0,                   // Extended possibilites for variation 
           AppName,             // Classname 
           AppName,             // Title Text 
           WS_OVERLAPPEDWINDOW, // default window 
           CW_USEDEFAULT,       // Windows decides the position 
           CW_USEDEFAULT,       // where the window ends up on the screen 
           Wid,                 // The programs width 
           Hei,                 // and height in pixels 
           HWND_DESKTOP,        // The window is a child-window to desktop 
           NULL,                // No menu 
           hInst,               // Program Instance handler 
           this
           );
}

//Special Forms
//Mode=1:menu and icon, Visible
//Mode=2:icon only, no menu, Visible
//Mode=3:menu and icon, Unvisible, ChildOfMainForm
//Mode=4:icon only, no menu, Unvisile, ChildOfMainForm
void FormClass::CreateSpecial(char * AppName,int StX,int StY,int Wid,int Hei,int Mode){
	WID=Wid;HEI=Hei;STX=StX;STY=StY;
	//Create Menuitem and icon 
	if((Mode==1)||(Mode==3)){
		
		WNDCLASSEX wincl;        // Data structure for the windowclass 
		// The Window structure
		wincl.hInstance = hInst;
		wincl.lpszClassName = AppName;
		wincl.lpfnWndProc = InitialWndProc;        // This function is called by windows 
		wincl.style = CS_DBLCLKS;                  // Catch double-clicks 
		wincl.cbSize = sizeof (WNDCLASSEX);		
		wincl.hIcon = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
		wincl.hIconSm = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
		wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
		wincl.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);	//MENU
		wincl.cbClsExtra = 0;                      // No extra bytes after the window class 
		wincl.cbWndExtra = 0;                      // structure or the window instance 
		wincl.hbrBackground = (HBRUSH) COLOR_WINDOW ;

		// Register the window class, and if it fails quit the program 
		if (!RegisterClassEx (&wincl)){
			MessageBox(NULL, TEXT("Error registering class"), TEXT("ERROR"), MB_OK | MB_ICONEXCLAMATION);
			return;
		}

		// The class is registered, let's create the program
		hwnd = CreateWindowEx (
           0,                   // Extended possibilites for variation 
           AppName,             // Classname 
           AppName,             // Title Text 
           WS_OVERLAPPEDWINDOW, // default window 
           StX,                 // Windows position 
           StY,                 // Windows position 
           Wid,                 // The programs width 
           Hei,                 // and height in pixels 
           HWND_DESKTOP,        // The window is a child-window to desktop 
           NULL,                // No menu 
           hInst,               // Program Instance handler 
           this
           );
		   
		HMENU	     hmenu1;
		hmenu1=LoadMenu(NULL,"ATOM");
		SetMenu(NULL,hmenu1);
		
		if(Mode==1){
			ChildOfMainForm=0;
			ShowWindow (hwnd, Fstil);
			Visible=true;
		}else{
			ChildOfMainForm=1;
			Visible=false;
		}
	}
	
	//Create Icon 
	if((Mode==2)||(Mode==4)){
		
		WNDCLASSEX wincl;        // Data structure for the windowclass 
		// The Window structure
		wincl.hInstance = hInst;
		wincl.lpszClassName = AppName;
		wincl.lpfnWndProc = InitialWndProc;        // This function is called by windows 
		wincl.style = CS_DBLCLKS;                  // Catch double-clicks 
		wincl.cbSize = sizeof (WNDCLASSEX);
		wincl.hIcon = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
		wincl.hIconSm = LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
		wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
		wincl.lpszMenuName = NULL;                 // No menu
		wincl.cbClsExtra = 0;                      // No extra bytes after the window class 
		wincl.cbWndExtra = 0;                      // structure or the window instance 
		wincl.hbrBackground = (HBRUSH) COLOR_WINDOW ;

		// Register the window class, and if it fails quit the program 
		if (!RegisterClassEx (&wincl)){
			MessageBox(NULL, TEXT("Error registering class"), TEXT("ERROR"), MB_OK | MB_ICONEXCLAMATION);
			return;
		}

		// The class is registered, let's create the program
		hwnd = CreateWindowEx (
           0,                   // Extended possibilites for variation 
           AppName,             // Classname 
           AppName,             // Title Text 
           WS_OVERLAPPEDWINDOW, // default window 
           StX,                 // Windows position 
           StY,                 // Windows position 
           Wid,                 // The programs width 
           Hei,                 // and height in pixels 
           HWND_DESKTOP,        // The window is a child-window to desktop 
           NULL,                // No menu 
           hInst,               // Program Instance handler 
           this
           );
		if(Mode==2){
			ChildOfMainForm=0;
			ShowWindow (hwnd, Fstil);
			Visible=true;
		}else{
			ChildOfMainForm=1;
			Visible=false;
		}
	}
}

//Create Dialog Box 
void FormClass::CreateDialogBox(HWND Owner,int Resource){
	DialogOwner=Owner;
	DialogResource=Resource;
}

//Dialog Box function: Show
int FormClass::ShowModal(){
	return DialogBoxParam(hInst,MAKEINTRESOURCE(DialogResource),DialogOwner,InitialDialogFunc,reinterpret_cast<LPARAM>(this));
}

//Dialog Box function: Return result and close dialog
void FormClass::ModalResult(int result){
	EndDialog(DialogHWND,result);
}

void FormClass::Show(){
    ShowWindow (hwnd, /*Fstil | */SW_SHOW);
    Visible=true;
    OnShow();
}

void FormClass::Hide(){
    ShowWindow (hwnd, SW_HIDE);
    Visible=false;
}

void FormClass::Update(){
	InvalidateRect(hwnd,NULL,FALSE);
}

void FormClass::Title(char* title){
	SendMessage(hwnd,WM_SETTEXT,0,(LPARAM)title);
}

FormClass::FormClass(){
	STX=-1;
	STY=-1;
	WID=-1;
	HEI=-1;
	DialogHWND=NULL;
}


FormClass::~FormClass(){
}


void FormClass::OnCommand(WORD command){}
void FormClass::OnKeyDown(WPARAM w){}
void FormClass::OnKeyUp(WPARAM w){}
void FormClass::OnChar(char ch){}
void FormClass::OnMouseButton(int X,int Y){}
void FormClass::OnMouseButtonUp(int X,int Y){}
void FormClass::OnMouseMove(int X,int Y){}
void FormClass::BuildForm(HWND Bhwnd,HINSTANCE BhInst){}
void FormClass::DestroyForm(){}
void FormClass::OnPaint(){}
void FormClass::OnShow(){}
void FormClass::OnMouseRightBtn(int X,int Y){}
void FormClass::OnMouseRightBtnUp(int X,int Y){}
void FormClass::OnMouseDbClick(int X,int Y){}
void FormClass::OnTimer(unsigned TimerID){}
void FormClass::Activate(int act){}
void FormClass::OnUserMessage(WPARAM wParam, LPARAM lParam){}
void FormClass::ComboChange(){}
void FormClass::OnAudioRecData(){}
void FormClass::OnNotify(NMHDR*notif){}
void FormClass::Hscroll(){}
void FormClass::Vscroll(){}


//******************************************************************************
//            WindowProcedure
//******************************************************************************

LRESULT FormClass::WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    
    //Call the owner form's callback functions
    int xPos,yPos;
    switch (message)
    {
        case WM_CREATE:              //Entry
			BuildForm(hwnd,hInst);
            break;
             
        case WM_CLOSE:
            if(ChildOfMainForm){
               Hide();
            }else{
               DefWindowProc (hwnd, message, wParam, lParam);
            }
            break;
             
        case WM_DESTROY:             //Exiting
            PostQuitMessage (0);
            break;
             
    	case WM_COMMAND:
            OnCommand(LOWORD(wParam));
			if(HIWORD(wParam) == CBN_SELCHANGE)
				ComboChange();
            break;
                 
		case WM_KEYDOWN:	          //Keyboard
	        OnKeyDown(wParam);
            break;
			
		case WM_KEYUP:
			OnKeyUp(wParam);
			break;
            
		case WM_CHAR:                 //Keyboard char
	        OnChar( (char)wParam);
            break;
			
		case WM_LBUTTONDOWN:          //Mouse left button down
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseButton(xPos,yPos);
            break;
            
		case WM_LBUTTONUP:           //Mouse left button up
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseButtonUp(xPos,yPos);
            break;
			
		case WM_LBUTTONDBLCLK:		 //Mouse left button double click
			xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
			OnMouseDbClick(xPos,yPos);
			break;

		case WM_RBUTTONDOWN:          //Mouse right button down
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseRightBtn(xPos,yPos);
            break;
            
		case WM_RBUTTONUP:           //Mouse right button up
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseRightBtnUp(xPos,yPos);
            break;
			
		case WM_MOUSEMOVE:            //Mouse movement
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseMove(xPos,yPos);
            break;
            
        case WM_PAINT:
            OnPaint();
			return DefWindowProc (hwnd, message, wParam, lParam);
            break;
			
		case WM_TIMER:
			OnTimer(wParam);
			break;
			
		case WM_SIZE:
			MoveWindow(hwnd,STX,STY,WID,HEI,true);
			break;
			
		case WM_ACTIVATE:
			if(wParam==WA_ACTIVE)Activate(1);
			if(wParam==WA_CLICKACTIVE)Activate(2);
			if(wParam==WA_INACTIVE)Activate(3);
			break;
			
		case WM_USER:
			OnUserMessage(wParam, lParam);
			break;
			
		case WIM_DATA:
			OnAudioRecData();
			break;
			
		case WM_NOTIFY:
			OnNotify((NMHDR*)lParam);
			break;
			
		case WM_HSCROLL:
			Hscroll();
			break;
			
		case WM_VSCROLL:
			Vscroll();
			break;
			
        default:
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


//******************************************************************************
//            Dialog Procedure
//******************************************************************************
BOOL CALLBACK FormClass::DialogFunc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;
	DialogHWND=hDlg;
	WINDOWINFO Winf;
	int xPos,yPos;

	switch(Msg){
		case WM_INITDIALOG:
			HICON hicon=LoadIcon (hInst, MAKEINTRESOURCE(IDI_ICON1));
			SendMessage(hDlg,WM_SETICON,0,(LPARAM)hicon);
			GetWindowInfo(hDlg,&Winf);
			
			if(STX==-1)STX=Winf.rcWindow.left;
			if(STY==-1)STY=Winf.rcWindow.top;
			if(WID==-1)WID=Winf.rcWindow.right-Winf.rcWindow.left;
			if(HEI==-1)HEI=Winf.rcWindow.bottom-Winf.rcWindow.top;
			
			BuildForm(hDlg,hInst);
			return TRUE;

		case WM_PAINT:
			OnPaint();
			hdc = BeginPaint (hDlg, &ps);  // Get DC handle
			EndPaint (hDlg, &ps);          // Release DC
			return TRUE;

		case WM_COMMAND:
			OnCommand(LOWORD(wParam));
			return TRUE;
		
		case WM_DESTROY:
			DestroyForm();
			return TRUE;
			
        case WM_SYSKEYDOWN:      //keyboard
			OnKeyDown(wParam);
            return TRUE;
			
        case WM_CLOSE:
			ModalResult(mrCancel);
            return TRUE;
			
		case WM_KEYDOWN:	          //Keyboard
	        OnKeyDown(wParam);
            return TRUE;
			
		case WM_KEYUP:
			OnKeyUp(wParam);
			break;
            
		case WM_CHAR:                 //Keyboard char
	        OnChar( (char)wParam);
            return TRUE;
			
		case WM_SIZE:
			MoveWindow(hDlg,STX,STY,WID,HEI,true);
			return TRUE;
		
		case WM_SIZING:
			MoveWindow(hDlg,STX,STY,WID,HEI,true);
			return TRUE;
			
		case WM_LBUTTONDOWN:          //Mouse left button down
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseButton(xPos,yPos);
            return TRUE;
            
		case WM_LBUTTONUP:           //Mouse left button up
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseButtonUp(xPos,yPos);
            return TRUE;
			
		case WM_LBUTTONDBLCLK:		 //Mouse left button double click
			xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
			OnMouseDbClick(xPos,yPos);
			return TRUE;

		case WM_RBUTTONDOWN:          //Mouse right button down
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseRightBtn(xPos,yPos);
            return TRUE;
            
		case WM_RBUTTONUP:           //Mouse right button up
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseRightBtnUp(xPos,yPos);
            return TRUE;
			
		case WM_MOUSEMOVE:            //Mouse movement
            xPos = LOWORD(lParam);
            yPos = HIWORD(lParam);
            OnMouseMove(xPos,yPos);
            return TRUE;
            	
		case WM_TIMER:
			OnTimer(wParam);
			return TRUE;
			
		case WM_ACTIVATE:
			if(wParam==WA_ACTIVE)Activate(1);
			if(wParam==WA_CLICKACTIVE)Activate(2);
			if(wParam==WA_INACTIVE)Activate(3);
			return TRUE;
			
	}
	return FALSE;
}
