//Memo Class
#ifndef MemoClassH
#define MemoClassH

#include <windows.h>
#include <stdio.h>
#include "AnsiString.h"
#include "TStringListClass.h"

static WNDPROC MemoProcAddr;

class Memo;

class MemoStrings{
    AnsiString LineStr;
  public:
    Memo* OwnerMemo;
    MemoStrings();
    ~MemoStrings();
    AnsiString& operator[] (unsigned i);
    AnsiString& GetLine(unsigned i);
};

class MemoLines{
  public:
    Memo* OwnerMemo;
    MemoLines();
    ~MemoLines();
    //void Add(AnsiString& str);
	void Add(AnsiString str);
    void Add(char* str);
    void Clear();
    void BeginUpdate();
	void EndUpdate();
    void LoadFromFile(AnsiString& FileName);
    void LoadFromFile(char* FileName);
    void SaveToFile(AnsiString& FileName);
    void SaveToFile(char* FileName);
    int Count();
    MemoStrings Strings;
};

class Memo{
	HFONT hFont;
  public:
    HWND MemoHwnd;
    int ID;
    Memo(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
	Memo(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size,int Mode);
	void MemoInit();
    ~Memo();
    void Clear();
    void LoadFromFile(AnsiString& FileName);
    void LoadFromFile(char* FileName);
    void SaveToFile(AnsiString& FileName);
    void SaveToFile(char* FileName);
    void BeginUpdate();
	void EndUpdate();
    void Add(AnsiString str);
    void Add(char* str);
    int Count();
    MemoStrings Strings;
    MemoLines* Lines;
	int VisibleLineCnt;
	void EnsureVisible(unsigned line);
	void SelectLine(unsigned line);
	unsigned LastSelectedLine;
	DWORD MaxCharCnt;
	void ReadOnly(bool RO);
	void SetDefFont();
	char Update;
	char* TextBuf;
	void LoadText(TStringList* Text);
	TStringList* ListBuf;
	
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		//char c;
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				//c=(char)wParam;
				//if((c>='a')&&(c<='z'))break;
				//if((c>='A')&&(c<='Z'))break;
				//if((c>='0')&&(c<='9'))break;
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
				
			case WM_GETDLGCODE:
				if(wParam==VK_RETURN)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,13,0);
				if(wParam==VK_TAB)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_TAB,0);
				if(wParam==VK_ESCAPE)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_ESCAPE,0);
				break;
		}
		return CallWindowProc (MemoProcAddr,hWnd, Msg, wParam, lParam);
    }

};

#endif
