//TEvent class
#include "TEventClass.h"
#include "AnsiString.h"

TEvent::TEvent(char* name){
    gEvent = CreateEvent( 
        NULL,               // default security attributes
        TRUE,               // manual-reset event
        FALSE,              // initial state is nonsignaled
        name                // object name
        ); 

    if (gEvent == NULL) {
        ShowMessage("CreateEvent failed");
    }
}

TEvent::~TEvent(){
	if(gEvent)CloseHandle(gEvent);
}

void TEvent::Set(){
	if(!gEvent)return;
    if (! SetEvent(gEvent) ) {
        ShowMessage("SetEvent failed");
    }
}

void TEvent::Reset(){
	if(!gEvent)return;
    if (! ResetEvent(gEvent) ) {
        ShowMessage("ResetEvent failed");
    }
}
    
int TEvent::WaitFor(long msec){
	DWORD res=WaitForSingleObject(gEvent,msec);
	if(res==WAIT_FAILED){
		ShowMessage("TEvent::WaitFor WAIT_FAILED");
		return eTimeout;
	}
	if(res==WAIT_TIMEOUT){
		ShowMessage("TEvent::WaitFor WAIT_TIMEOUT");
		return eTimeout;
	}
	if(res==WAIT_OBJECT_0){
		ShowMessage("TEvent::WaitFor WAIT_OBJECT_0");
		return eFired;
	}	
}
