//Thread Class
#include "ThreadClass.h"

Thread::Thread(bool Suspended){
    DWORD dwCreationFlags=0;
    if(Suspended)dwCreationFlags=CREATE_SUSPENDED;
    
    HThread=CreateThread( 
            NULL,                  // default security attributes
            0,                     // use default stack size  
            ThreadFunction,        // thread function name
            (LPVOID)this,          // argument to thread function 
            dwCreationFlags,       // creation flags 
            &dwThreadId);          // returns the thread identifier 
            
    Terminated=0;
}

Thread::~Thread(){
    CloseHandle(HThread);
}

void __fastcall Thread::Execute(){
    
}

void __fastcall Thread::Resume(){
    ResumeThread(HThread);
}

void Thread::Synchronize(SynchronizedFunc SF){
     SF();
}

void Thread::Terminate(){
    Terminated=1;
    OnTerminate();
}

void Thread::OnTerminate(){
}

//http://msdn.microsoft.com/en-us/library/windows/desktop/ms682453(v=vs.85).aspx
//http://msdn.microsoft.com/en-us/library/windows/desktop/ms682516(v=vs.85).aspx
