//Hash table
#include "hash.h"

Hash::Hash(){
	Create(DEFTABLE);
}

//n=desired hash table size
Hash::Hash(int n){
	Create(n);
}

void Hash::Create(int n){
	if(n<DEFTABLE)
		n=DEFTABLE;
	if(n>2000000)
		n=2000000;
	Htab.push_back(NULL);
	Htab.resize(n,NULL);
	Tablesize=n;
	itemCnt=0;
	FindP=-1;
}

Hash::~Hash(){
	Htab.clear();
}

int Hash::hash(char *str){
	int hash = 5381;
	int c;
	while (c = *str++)
		hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
	return (hash&0x7FFFFFFF)%Tablesize;
}

//return 1 if no error
int Hash::Add(Hashable*item){
	if(itemCnt>1500000)
		return 0;
	int H;
	
	//resize table, rehash every element
	if((Tablesize < itemCnt*2) && (Tablesize<2000000)){
		int x;
		Tablesize=itemCnt*10;
		if(Tablesize>2000000)Tablesize=2000000;
		std::vector<Hashable*> tempHtab;
		for(x=0;x<Htab.size();x++){
			if(Htab[x]){
				tempHtab.push_back(Htab[x]);
				Htab[x]=NULL;
			}
		}
		Htab.resize(Tablesize,NULL);
		for(x=0;x<tempHtab.size();x++){
			H=hash(tempHtab[x]->name);
			while(Htab[H]!=NULL){
				H=(H+1)%Tablesize;
			}
			Htab[H]=tempHtab[x];
		}
		tempHtab.clear();
	}
	
	//hash item
	H=hash(item->name);
	while(Htab[H]!=NULL){
		H=(H+1)%Tablesize;
	}
	Htab[H]=item;
	itemCnt++;
	return 1;
}

Hashable* Hash::At(char* str){
	int H=hash(str);
	while(Htab[H]!=NULL){
		if(!strcmp(str,Htab[H]->name)){
			break;
		}
		H=(H+1)%Tablesize;
	}
	return Htab[H];
}

Hashable* Hash::FindFirst(){
	Hashable* p=NULL;
	for(FindP=0;FindP<Htab.size();FindP++){
		if(Htab[FindP]){
			p=Htab[FindP];
			break;
		}
	}
	return p;
}

Hashable* Hash::FindNext(){
	if(FindP<0)
		return NULL;
	Hashable* p=NULL;
	for(FindP++;FindP<Htab.size();FindP++){
		if(Htab[FindP]){
			p=Htab[FindP];
			break;
		}
	}
	return p;
}
