//Hash table
#include <vector>

#define DEFTABLE 1024

class Hashable{
public:
	char name[20];
};

class Hash{
public:
	Hash();
	Hash(int n);
	~Hash();
	
	int Tablesize;
	int itemCnt;
	
	int Add(Hashable*item);
	Hashable* At(char* str);
	
	Hashable* FindFirst();
	Hashable* FindNext();
	
private:
	std::vector<Hashable*> Htab;
	int hash(char *str);
	void Create(int n);
	int FindP;
};


//USAGE EXAMPLE:
/*
//hash table
#include "..\hash.h"

class Nev : public Hashable{
public:
	int x;
};

Nev* N;
Hash H;

void AddTo(char* name){
	static int cnt=0;
	strcpy(N[cnt].name,name);
	N[cnt].x=cnt+1;
	
	H.Add(&N[cnt]);
	cnt++;
}

void Lookup(char*name){
	Nev*f;
	f=(Nev*)H.At(name);
	if(f==NULL){
		printf("NULL\n");
	}else{
		printf("%s %d\n",f->name,f->x);
	}
}

void test(){
	//lookup
	Lookup("MIVAN");
	Lookup("ATOM");
	Lookup("murva");
	Lookup("uhha");
	Lookup("MARI");
	Lookup("FAZS");
	Lookup("UHU");
	Lookup("EKE");
}

void PrintAll(){
	Nev*f;
	f=(Nev*)H.FindFirst();
	if(f){
		printf("%s\n",f->name);
		while(f=(Nev*)H.FindNext()){
			printf("%s\n",f->name);
		}
	}else{
		printf("No data to print\n");
	}
}

int main(int argc, char* argv[]){
	N=new Nev[10];
	AddTo("BUMM");	//1
	AddTo("HAHA");	//2
	AddTo("MARI");	//3
	AddTo("FAZS");	//4
	AddTo("UHU");	//5
	AddTo("EKE");	//6
	
	//test();
	
	AddTo("MIVAN");	//7
	AddTo("BAROm");	//8
	AddTo("");	//9
	AddTo("murva");	//10
	AddTo("atom");	//11
	AddTo("robbant");	//12
	
	//test();
	
	PrintAll();

	delete[] N;

    return 0;
}


*/
