//define __property

#ifndef propertiesH
#define propertiesH

template<typename class_T, typename T, typename const_reference_T =const T&> class property {
public:
typedef T value_type;
typedef const_reference_T const_reference_type;
typedef class_T class_type;

typedef const_reference_type (class_type::*get_type)() const;
typedef void (class_type::*set_type)(const_reference_type);
typedef value_type& (class_type::*get_ref_type)();

public:
property(class_type* p_obj, get_type p_get_fun, set_type p_set_fun,
get_ref_type p_get_ref_fun) : m_p_obj(p_obj), m_p_get_fun(p_get_fun),
m_p_set_fun(p_set_fun), m_p_get_ref_fun(p_get_ref_fun) {}

T& operator =(const_reference_type value) {
(m_p_obj->*m_p_set_fun)(value);
return (m_p_obj->*m_p_get_ref_fun)();
}

operator const_reference_type() {
return (m_p_obj->*m_p_get_fun)();
}

private:
class_type* m_p_obj;

get_type m_p_get_fun;
set_type m_p_set_fun;
get_ref_type m_p_get_ref_fun;

};

#endif
