#include <windows.h>
#include <memory.h>
#include <vector>

#define SHMEMSIZE 16384
#define MAXLEN 1024

static LPVOID lpvMem = NULL;      // pointer to shared memory
static HANDLE hMapObject = NULL;  // handle to file mapping

static std::vector<long> fifo;

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved){ 
    BOOL fInit, fIgnore;
	WORD size;
	char* poi;
 
    switch (fdwReason){
		case DLL_PROCESS_ATTACH: 
            hMapObject = CreateFileMapping( 
                INVALID_HANDLE_VALUE,   // use paging file
                NULL,                   // default security attributes
                PAGE_READWRITE,         // read/write access
                0,                      // size: high 32-bits
                SHMEMSIZE,              // size: low 32-bits
                TEXT("dllmemfilemap")); // name of map object
            if (hMapObject == NULL) 
                return FALSE; 
 
            fInit = (GetLastError() != ERROR_ALREADY_EXISTS); 
 
            lpvMem = MapViewOfFile( 
                hMapObject,     // object to map view of
                FILE_MAP_WRITE, // read/write access
                0,              // high offset:  map from
                0,              // low offset:   beginning
                0);             // default: map entire file
            if (lpvMem == NULL) 
                return FALSE; 
 
            //if (fInit) memset(lpvMem, '\0', SHMEMSIZE); 
			size=SHMEMSIZE;
			poi=(char*)lpvMem;
			poi[0]=(char)HIBYTE(size);	//block size = full
			poi[1]=(char)LOBYTE(size);
			poi[2]=0;					//0: empty block
 
            break; 
 
        case DLL_THREAD_ATTACH: 
            break; 
 
        case DLL_THREAD_DETACH: 
            break; 
 
        case DLL_PROCESS_DETACH: 
            fIgnore = UnmapViewOfFile(lpvMem); 
            fIgnore = CloseHandle(hMapObject); 
            break; 
 
        default: 
          break; 
     } 
 
    return TRUE; 
} 

 
int FIFOpush(char* str, long buflen){
    long poi=0;
	char* buf;
	WORD size;
	WORD newsize;
	char free;
	int van;
	long x;
	
	if((buflen>MAXLEN)||(buflen<=0)||!str)
		return 0;

	buf=(char*)lpvMem;
	van=0;
	while(poi<SHMEMSIZE){
		size=buf[poi]*256+buf[poi+1];
		free=buf[poi+2];
		if(free&&(size>buflen+5)){
			van=1;
			break;
		}
		poi+=size;
	}

	if(!van)
		return 0;
		
	//is it to fragment free space?
	//minimum allocated place is 200 byte
	if((buflen+200)>size){
		newsize=buflen+3;
		buf[poi]=(char)HIBYTE(newsize);
		buf[poi+1]=(char)LOBYTE(newsize);
		size-=newsize;
		buf[poi+newsize]=(char)HIBYTE(size);
		buf[poi+newsize+1]=(char)HIBYTE(size);
		buf[poi+newsize+2]=0;
	}
	buf[poi+2]=1;
	
	for(x=0;x<buflen;x++){
		buf[poi+3+x]=str[x];
	}
	
	fifo.push_back(poi);
	
	return 1;
} 


int FIFOget(char* str, long* buflen){
	if(fifo.size()==0)
		return 0;
	
	long elem=fifo.front();
	fifo.erase(fifo.begin());
	
	char* buf=(char*)lpvMem;
	*buflen=(long)(buf[elem]*256+buf[elem+1]);
	buf[elem+2]=0;
	
	long x;
	for(x=0;x<*buflen;x++){
		str[x]=buf[elem+3+x];
	}
	
	//defrag
	long poi=0;
	WORD size;
	char free;
	while(poi<SHMEMSIZE){
		size=buf[poi]*256+buf[poi+1];
		free=buf[poi+2];
		while(free&&((size+poi+3)<SHMEMSIZE)&&(buf[size+poi+2]==0)){
			size+=buf[size+poi]*256+buf[size+poi+1];
			buf[poi]=(char)HIBYTE(size);
			buf[poi+1]=(char)HIBYTE(size);
			for (std::vector<long>::iterator i = fifo.begin(); i != fifo.end(); ++i){
				if(*i==size+poi){
					fifo.erase(i);
					break;
				}
			}
		}
		poi+=size;
	}
	return 1;
}
